/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-06-05 16:09:48 UTC)
 * on 2013-06-10 at 21:18:48 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.reseller.model;

/**
 * JSON template for the ChangePlan rpc request.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Enterprise Apps Reseller API. For a detailed
 * explanation see:
 * <a href="http://code.google.com/p/google-http-java-client/wiki/JSON">http://code.google.com/p/google-http-java-client/wiki/JSON</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class ChangePlanRequest extends com.google.api.client.json.GenericJson {

  /**
   * Identifies the resource as a subscription change plan request.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String kind;

  /**
   * Name of the plan to change to.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String planName;

  /**
   * Purchase order id for your order tracking purposes.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String purchaseOrderId;

  /**
   * Number/Limit of seats in the new plan.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Seats seats;

  /**
   * Identifies the resource as a subscription change plan request.
   * @return value or {@code null} for none
   */
  public java.lang.String getKind() {
    return kind;
  }

  /**
   * Identifies the resource as a subscription change plan request.
   * @param kind kind or {@code null} for none
   */
  public ChangePlanRequest setKind(java.lang.String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * Name of the plan to change to.
   * @return value or {@code null} for none
   */
  public java.lang.String getPlanName() {
    return planName;
  }

  /**
   * Name of the plan to change to.
   * @param planName planName or {@code null} for none
   */
  public ChangePlanRequest setPlanName(java.lang.String planName) {
    this.planName = planName;
    return this;
  }

  /**
   * Purchase order id for your order tracking purposes.
   * @return value or {@code null} for none
   */
  public java.lang.String getPurchaseOrderId() {
    return purchaseOrderId;
  }

  /**
   * Purchase order id for your order tracking purposes.
   * @param purchaseOrderId purchaseOrderId or {@code null} for none
   */
  public ChangePlanRequest setPurchaseOrderId(java.lang.String purchaseOrderId) {
    this.purchaseOrderId = purchaseOrderId;
    return this;
  }

  /**
   * Number/Limit of seats in the new plan.
   * @return value or {@code null} for none
   */
  public Seats getSeats() {
    return seats;
  }

  /**
   * Number/Limit of seats in the new plan.
   * @param seats seats or {@code null} for none
   */
  public ChangePlanRequest setSeats(Seats seats) {
    this.seats = seats;
    return this;
  }

  @Override
  public ChangePlanRequest set(String fieldName, Object value) {
    return (ChangePlanRequest) super.set(fieldName, value);
  }

  @Override
  public ChangePlanRequest clone() {
    return (ChangePlanRequest) super.clone();
  }

}
